<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'telephoneNumberType' => '\\StructType\\TelephoneNumberType',
            'telephoneNumber' => '\\StructType\\TelephoneNumber',
            'addressExtType' => '\\StructType\\AddressExtType',
            'addressLodgeType' => '\\StructType\\AddressLodgeType',
            'physicalAddress' => '\\StructType\\PhysicalAddress',
            'unstructuredAddress' => '\\StructType\\UnstructuredAddress',
            'semiStructuredPhysicalAddress' => '\\StructType\\SemiStructuredPhysicalAddress',
            'distinguishedNameExtType' => '\\StructType\\DistinguishedNameExtType',
            'distinguishedNameType' => '\\StructType\\DistinguishedNameType',
            'personNameType' => '\\StructType\\PersonNameType',
            'personNameOptionalType' => '\\StructType\\PersonNameOptionalType',
            'personNameLodgeType' => '\\StructType\\PersonNameLodgeType',
            'personNameWithRoleType' => '\\StructType\\PersonNameWithRoleType',
            'birthDetailsType' => '\\StructType\\BirthDetailsType',
            'birthDetailsExtType' => '\\StructType\\BirthDetailsExtType',
            'birthDetailsLodgeType' => '\\StructType\\BirthDetailsLodgeType',
            'personNameBirthType' => '\\StructType\\PersonNameBirthType',
            'personNameFormerNameType' => '\\StructType\\PersonNameFormerNameType',
            'statusType' => '\\StructType\\StatusType',
            'intervalStatusType' => '\\StructType\\IntervalStatusType',
            'organisationIdentifierType' => '\\StructType\\OrganisationIdentifierType',
            'organisationNamePlusIdType' => '\\StructType\\OrganisationNamePlusIdType',
            'textType' => '\\StructType\\TextType',
            'signatoryType' => '\\StructType\\SignatoryType',
            'asicSignatoryType' => '\\StructType\\AsicSignatoryType',
            'companySignatoryType' => '\\StructType\\CompanySignatoryType',
            'messageIdentifierType' => '\\StructType\\MessageIdentifierType',
            'customerIdentifier' => '\\StructType\\CustomerIdentifier',
            'identifier' => '\\StructType\\Identifier',
            'documentIdentifierType' => '\\StructType\\DocumentIdentifierType',
            'ebusiness' => '\\StructType\\Ebusiness',
            'ascot' => '\\StructType\\Ascot',
            'browserIdentifierType' => '\\StructType\\BrowserIdentifierType',
            'soapSoftwareIdentifierType' => '\\StructType\\SoapSoftwareIdentifierType',
            'realmIdentifierType' => '\\StructType\\RealmIdentifierType',
            'realmQualifierType' => '\\StructType\\RealmQualifierType',
            'accountIdentifierType' => '\\StructType\\AccountIdentifierType',
            'rejectedType' => '\\StructType\\RejectedType',
            'standardHeaderType' => '\\StructType\\StandardHeaderType',
            'standardMessageHeaderType' => '\\StructType\\StandardMessageHeaderType',
            'requestType' => '\\StructType\\RequestType',
            'replyType' => '\\StructType\\ReplyType',
            'result' => '\\StructType\\Result',
            'resultType' => '\\StructType\\ResultType',
            'timestampType' => '\\StructType\\TimestampType',
            'timestampListType' => '\\StructType\\TimestampListType',
            'exceptionType' => '\\StructType\\ExceptionType',
            'context' => '\\StructType\\Context',
            'exceptionListType' => '\\StructType\\ExceptionListType',
            'traceType' => '\\StructType\\TraceType',
            'traceListType' => '\\StructType\\TraceListType',
            'paymentType' => '\\StructType\\PaymentType',
            'creditCardType' => '\\StructType\\CreditCardType',
            'nameType' => '\\StructType\\NameType',
            'fileNotesType' => '\\StructType\\FileNotesType',
            'inboxIdentifierType' => '\\StructType\\InboxIdentifierType',
            'lodgementIdentifierType' => '\\StructType\\LodgementIdentifierType',
            'outboundItemIdentifierType' => '\\StructType\\OutboundItemIdentifierType',
            'itemSearchScopeType' => '\\StructType\\ItemSearchScopeType',
            'itemSummaryType' => '\\StructType\\ItemSummaryType',
            'entityType' => '\\StructType\\EntityType',
            'agentType' => '\\StructType\\AgentType',
            'objectionType' => '\\StructType\\ObjectionType',
            'flagType' => '\\StructType\\FlagType',
            'nameResultType' => '\\StructType\\NameResultType',
            'nameResultWithObjectionsType' => '\\StructType\\NameResultWithObjectionsType',
            'nameAvailabilityType' => '\\StructType\\NameAvailabilityType',
            'nameAvailabilityResponseType' => '\\StructType\\NameAvailabilityResponseType',
            'businessNameIdentifierType' => '\\StructType\\BusinessNameIdentifierType',
            'requestRejectedType' => '\\StructType\\RequestRejectedType',
            'requestFailedType' => '\\StructType\\RequestFailedType',
            'actionType' => '\\StructType\\ActionType',
            'abnRecordType' => '\\StructType\\AbnRecordType',
            'ANZSIC' => '\\StructType\\ANZSIC',
            'goodsAndServicesTax' => '\\StructType\\GoodsAndServicesTax',
            'deductibleGiftRecipient' => '\\StructType\\DeductibleGiftRecipient',
            'legalName' => '\\StructType\\LegalName',
            'organisation' => '\\StructType\\Organisation',
            'individual' => '\\StructType\\Individual',
            'mainTradingName' => '\\StructType\\MainTradingName',
            'otherTradingName' => '\\StructType\\OtherTradingName',
            'associate' => '\\StructType\\Associate',
            'relationship' => '\\StructType\\Relationship',
            'organisationNameType' => '\\StructType\\OrganisationNameType',
            'identifierType' => '\\StructType\\IdentifierType',
            'individualNameType' => '\\StructType\\IndividualNameType',
            'geographicType' => '\\StructType\\GeographicType',
            'searchIdentifierType' => '\\StructType\\SearchIdentifierType',
            'baseAbrEntityType' => '\\StructType\\BaseAbrEntityType',
            'abrEntityType' => '\\StructType\\AbrEntityType',
            'abnEmailType' => '\\StructType\\AbnEmailType',
            'abnUpdateType' => '\\StructType\\AbnUpdateType',
            'fssCustomerType' => '\\StructType\\FssCustomerType',
            'agent' => '\\StructType\\Agent',
            'billingAddress' => '\\StructType\\BillingAddress',
            'fssSimpleAccountType' => '\\StructType\\FssSimpleAccountType',
            'fssAccountType' => '\\StructType\\FssAccountType',
            'fssItemType' => '\\StructType\\FssItemType',
            'feeType' => '\\StructType\\FeeType',
            'feesType' => '\\StructType\\FeesType',
            'invoice' => '\\StructType\\Invoice',
            'debtorDetail' => '\\StructType\\DebtorDetail',
            'invoiceItems' => '\\StructType\\InvoiceItems',
            'item' => '\\StructType\\Item',
            'fssTransactionType' => '\\StructType\\FssTransactionType',
            'transactionType' => '\\StructType\\TransactionType',
            'invoiceType' => '\\StructType\\InvoiceType',
            'invoicePeriod' => '\\StructType\\InvoicePeriod',
            'asicPaymentDetails' => '\\StructType\\AsicPaymentDetails',
            'bpay' => '\\StructType\\Bpay',
            'postBillpay' => '\\StructType\\PostBillpay',
            'receiptType' => '\\StructType\\ReceiptType',
            'paymentDetailsType' => '\\StructType\\PaymentDetailsType',
            'transactionsType' => '\\StructType\\TransactionsType',
            'debtorType' => '\\StructType\\DebtorType',
            'feeWithAmountType' => '\\StructType\\FeeWithAmountType',
            'priceType' => '\\StructType\\PriceType',
            'asicPaymentDetailsType' => '\\StructType\\AsicPaymentDetailsType',
            'organisationLodgeType' => '\\StructType\\OrganisationLodgeType',
            'organisationType' => '\\StructType\\OrganisationType',
            'simpleBnExtractType' => '\\StructType\\SimpleBnExtractType',
            'businessNameExtractType' => '\\StructType\\BusinessNameExtractType',
            'business' => '\\StructType\\Business',
            'documentType' => '\\StructType\\DocumentType',
            'additionalDescription' => '\\StructType\\AdditionalDescription',
            'billingType' => '\\StructType\\BillingType',
            'charge' => '\\StructType\\Charge',
            'chargeType' => '\\StructType\\ChargeType',
            'previousStateTerritoryType' => '\\StructType\\PreviousStateTerritoryType',
            'contactPersonType' => '\\StructType\\ContactPersonType',
            'contactPersonWithAddressType' => '\\StructType\\ContactPersonWithAddressType',
            'outboundContactPersonType' => '\\StructType\\OutboundContactPersonType',
            'outboundContactPersonWithAddressType' => '\\StructType\\OutboundContactPersonWithAddressType',
            'personWithRolesType' => '\\StructType\\PersonWithRolesType',
            'personsWithRolesType' => '\\StructType\\PersonsWithRolesType',
            'bnCredentialsType' => '\\StructType\\BnCredentialsType',
            'outboundBusinessNameType' => '\\StructType\\OutboundBusinessNameType',
            'bnLodgeFormType' => '\\StructType\\BnLodgeFormType',
            'bnRenewalFormType' => '\\StructType\\BnRenewalFormType',
            'bnUpdateFormType' => '\\StructType\\BnUpdateFormType',
            'bnCancelFormType' => '\\StructType\\BnCancelFormType',
            'bnLinkFormType' => '\\StructType\\BnLinkFormType',
            'individualType' => '\\StructType\\IndividualType',
            'businessEntityType' => '\\StructType\\BusinessEntityType',
            'associateType' => '\\StructType\\AssociateType',
            'partnerAssociateType' => '\\StructType\\PartnerAssociateType',
            'representativeType' => '\\StructType\\RepresentativeType',
            'personExtractRequestType' => '\\StructType\\PersonExtractRequestType',
            'personIds' => '\\StructType\\PersonIds',
            'bnGetRegistrationRecordRequestType' => '\\StructType\\BnGetRegistrationRecordRequestType',
            'registrationRecord' => '\\StructType\\RegistrationRecord',
            'bnSearchRequestType' => '\\StructType\\BnSearchRequestType',
            'search' => '\\StructType\\Search',
            'filter' => '\\StructType\\Filter',
            'locationType' => '\\StructType\\LocationType',
            'localityState' => '\\StructType\\LocalityState',
            'bnExtractRequestType' => '\\StructType\\BnExtractRequestType',
            'stateTerritory' => '\\StructType\\StateTerritory',
            'roleTypeType' => '\\StructType\\RoleTypeType',
            'reportDataType' => '\\StructType\\ReportDataType',
            'reportRequestType' => '\\StructType\\ReportRequestType',
            'periodType' => '\\StructType\\PeriodType',
            'bnIdentifier' => '\\StructType\\BnIdentifier',
            'businessEntityLodgeType' => '\\StructType\\BusinessEntityLodgeType',
            'associateLodgeType' => '\\StructType\\AssociateLodgeType',
            'partnerAssociateLodgeType' => '\\StructType\\PartnerAssociateLodgeType',
            'individualLodgeType' => '\\StructType\\IndividualLodgeType',
            'renewalReplyDataType' => '\\StructType\\RenewalReplyDataType',
            'renewalResultType' => '\\StructType\\RenewalResultType',
            'nniTypeType' => '\\StructType\\NniTypeType',
            'nameIndexAcncEntityType' => '\\StructType\\NameIndexAcncEntityType',
            'nameIndexEntityType' => '\\StructType\\NameIndexEntityType',
            'baseNniEntityType' => '\\StructType\\BaseNniEntityType',
            'formerName' => '\\StructType\\FormerName',
            'nniEntityType' => '\\StructType\\NniEntityType',
            'nniEntityWithAgentType' => '\\StructType\\NniEntityWithAgentType',
            'businessType' => '\\StructType\\BusinessType',
            'companyType' => '\\StructType\\CompanyType',
            'officeholders' => '\\StructType\\Officeholders',
            'shareholders' => '\\StructType\\Shareholders',
            'officeholderType' => '\\StructType\\OfficeholderType',
            'shareholderType' => '\\StructType\\ShareholderType',
            'outboundAgentType' => '\\StructType\\OutboundAgentType',
            'searchNniRequestType' => '\\StructType\\SearchNniRequestType',
            'queryNniNameType' => '\\StructType\\QueryNniNameType',
            'proprietor' => '\\StructType\\Proprietor',
            'classType' => '\\StructType\\ClassType',
            'companyExtractRequestType' => '\\StructType\\CompanyExtractRequestType',
            'company' => '\\StructType\\Company',
            'document' => '\\StructType\\Document',
            'base64Binary' => '\\StructType\\Base64Binary',
            'hexBinary' => '\\StructType\\HexBinary',
            'businessDocumentRequestHeaderType' => '\\StructType\\BusinessDocumentRequestHeaderType',
            'businessDocumentHeaderType' => '\\StructType\\BusinessDocumentHeaderType',
            'attachmentsType' => '\\StructType\\AttachmentsType',
            'attachmentType' => '\\StructType\\AttachmentType',
            'softwareInformationType' => '\\StructType\\SoftwareInformationType',
            'messageEventType' => '\\StructType\\MessageEventType',
            'messageTimestampsType' => '\\StructType\\MessageTimestampsType',
            'messageTimestampType' => '\\StructType\\MessageTimestampType',
            'messageEventsType' => '\\StructType\\MessageEventsType',
            'genericResultType' => '\\StructType\\GenericResultType',
            'AttributedDateTime' => '\\StructType\\AttributedDateTime',
            'AttributedURI' => '\\StructType\\AttributedURI',
            'TimestampType' => '\\StructType\\TimestampType_1',
            'queryNameAvailabilityRequestType' => '\\StructType\\QueryNameAvailabilityRequestType',
            'queryNameAvailabilityReplyType' => '\\StructType\\QueryNameAvailabilityReplyType',
        );
    }
}
