<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for debtorDetail StructType
 * @subpackage Structs
 */
class DebtorDetail extends AbstractStructBase
{
    /**
     * The prefix
     * Meta informations extracted from the WSDL
     * - maxLength: 12
     * @var string
     */
    public $prefix;
    /**
     * The suffix
     * Meta informations extracted from the WSDL
     * - maxLength: 60
     * @var string
     */
    public $suffix;
    /**
     * Constructor method for debtorDetail
     * @uses DebtorDetail::setPrefix()
     * @uses DebtorDetail::setSuffix()
     * @param string $prefix
     * @param string $suffix
     */
    public function __construct($prefix = null, $suffix = null)
    {
        $this
            ->setPrefix($prefix)
            ->setSuffix($suffix);
    }
    /**
     * Get prefix value
     * @return string|null
     */
    public function getPrefix()
    {
        return $this->prefix;
    }
    /**
     * Set prefix value
     * @param string $prefix
     * @return \StructType\DebtorDetail
     */
    public function setPrefix($prefix = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($prefix) && strlen($prefix) > 12) || (is_array($prefix) && count($prefix) > 12)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 12 element(s) or a scalar of 12 character(s) at most, "%d" length given', is_scalar($prefix) ? strlen($prefix) : count($prefix)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($prefix) && !is_string($prefix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prefix)), __LINE__);
        }
        $this->prefix = $prefix;
        return $this;
    }
    /**
     * Get suffix value
     * @return string|null
     */
    public function getSuffix()
    {
        return $this->suffix;
    }
    /**
     * Set suffix value
     * @param string $suffix
     * @return \StructType\DebtorDetail
     */
    public function setSuffix($suffix = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($suffix) && strlen($suffix) > 60) || (is_array($suffix) && count($suffix) > 60)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 60 element(s) or a scalar of 60 character(s) at most, "%d" length given', is_scalar($suffix) ? strlen($suffix) : count($suffix)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($suffix) && !is_string($suffix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($suffix)), __LINE__);
        }
        $this->suffix = $suffix;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DebtorDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
