<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for documentIdentifierType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Identity for a document in ASIC.
 * @subpackage Structs
 */
class DocumentIdentifierType extends AbstractStructBase
{
    /**
     * The ebusiness
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Ebusiness
     */
    public $ebusiness;
    /**
     * The ascot
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Ascot
     */
    public $ascot;
    /**
     * Constructor method for documentIdentifierType
     * @uses DocumentIdentifierType::setEbusiness()
     * @uses DocumentIdentifierType::setAscot()
     * @param \StructType\Ebusiness $ebusiness
     * @param \StructType\Ascot $ascot
     */
    public function __construct(\StructType\Ebusiness $ebusiness = null, \StructType\Ascot $ascot = null)
    {
        $this
            ->setEbusiness($ebusiness)
            ->setAscot($ascot);
    }
    /**
     * Get ebusiness value
     * @return \StructType\Ebusiness|null
     */
    public function getEbusiness()
    {
        return $this->ebusiness;
    }
    /**
     * Set ebusiness value
     * @param \StructType\Ebusiness $ebusiness
     * @return \StructType\DocumentIdentifierType
     */
    public function setEbusiness(\StructType\Ebusiness $ebusiness = null)
    {
        $this->ebusiness = $ebusiness;
        return $this;
    }
    /**
     * Get ascot value
     * @return \StructType\Ascot|null
     */
    public function getAscot()
    {
        return $this->ascot;
    }
    /**
     * Set ascot value
     * @param \StructType\Ascot $ascot
     * @return \StructType\DocumentIdentifierType
     */
    public function setAscot(\StructType\Ascot $ascot = null)
    {
        $this->ascot = $ascot;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DocumentIdentifierType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
