<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ebusiness StructType
 * @subpackage Structs
 */
class Ebusiness extends AbstractStructBase
{
    /**
     * The referenceNumber
     * Meta informations extracted from the WSDL
     * - maxInclusive: 99999999999
     * - minInclusive: 1
     * @var int
     */
    public $referenceNumber;
    /**
     * Constructor method for ebusiness
     * @uses Ebusiness::setReferenceNumber()
     * @param int $referenceNumber
     */
    public function __construct($referenceNumber = null)
    {
        $this
            ->setReferenceNumber($referenceNumber);
    }
    /**
     * Get referenceNumber value
     * @return int|null
     */
    public function getReferenceNumber()
    {
        return $this->referenceNumber;
    }
    /**
     * Set referenceNumber value
     * @param int $referenceNumber
     * @return \StructType\Ebusiness
     */
    public function setReferenceNumber($referenceNumber = null)
    {
        // validation for constraint: maxInclusive
        if ($referenceNumber > 99999999999) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be inferior or equal to 99999999999, "%s" given', $referenceNumber), __LINE__);
        }
        // validation for constraint: minInclusive
        if ($referenceNumber < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be superior or equal to 1, "%s" given', $referenceNumber), __LINE__);
        }
        // validation for constraint: int
        if (!is_null($referenceNumber) && !is_numeric($referenceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($referenceNumber)), __LINE__);
        }
        $this->referenceNumber = $referenceNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Ebusiness
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
