<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for exceptionListType StructType
 * @subpackage Structs
 */
class ExceptionListType extends AbstractStructBase
{
    /**
     * The item
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ExceptionType[]
     */
    public $item;
    /**
     * Constructor method for exceptionListType
     * @uses ExceptionListType::setItem()
     * @param \StructType\ExceptionType[] $item
     */
    public function __construct(array $item = array())
    {
        $this
            ->setItem($item);
    }
    /**
     * Get item value
     * @return \StructType\ExceptionType[]|null
     */
    public function getItem()
    {
        return $this->item;
    }
    /**
     * Set item value
     * @throws \InvalidArgumentException
     * @param \StructType\ExceptionType[] $item
     * @return \StructType\ExceptionListType
     */
    public function setItem(array $item = array())
    {
        foreach ($item as $exceptionListTypeItemItem) {
            // validation for constraint: itemType
            if (!$exceptionListTypeItemItem instanceof \StructType\ExceptionType) {
                throw new \InvalidArgumentException(sprintf('The item property can only contain items of \StructType\ExceptionType, "%s" given', is_object($exceptionListTypeItemItem) ? get_class($exceptionListTypeItemItem) : gettype($exceptionListTypeItemItem)), __LINE__);
            }
        }
        $this->item = $item;
        return $this;
    }
    /**
     * Add item to item value
     * @throws \InvalidArgumentException
     * @param \StructType\ExceptionType $item
     * @return \StructType\ExceptionListType
     */
    public function addToItem(\StructType\ExceptionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExceptionType) {
            throw new \InvalidArgumentException(sprintf('The item property can only contain items of \StructType\ExceptionType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->item[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExceptionListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
