<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for messageEventsType StructType
 * @subpackage Structs
 */
class MessageEventsType extends AbstractStructBase
{
    /**
     * The messageEvent
     * Meta informations extracted from the WSDL
     * - maxOccurs: 100
     * @var \StructType\MessageEventType[]
     */
    public $messageEvent;
    /**
     * Constructor method for messageEventsType
     * @uses MessageEventsType::setMessageEvent()
     * @param \StructType\MessageEventType[] $messageEvent
     */
    public function __construct(array $messageEvent = array())
    {
        $this
            ->setMessageEvent($messageEvent);
    }
    /**
     * Get messageEvent value
     * @return \StructType\MessageEventType[]|null
     */
    public function getMessageEvent()
    {
        return $this->messageEvent;
    }
    /**
     * Set messageEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\MessageEventType[] $messageEvent
     * @return \StructType\MessageEventsType
     */
    public function setMessageEvent(array $messageEvent = array())
    {
        foreach ($messageEvent as $messageEventsTypeMessageEventItem) {
            // validation for constraint: itemType
            if (!$messageEventsTypeMessageEventItem instanceof \StructType\MessageEventType) {
                throw new \InvalidArgumentException(sprintf('The messageEvent property can only contain items of \StructType\MessageEventType, "%s" given', is_object($messageEventsTypeMessageEventItem) ? get_class($messageEventsTypeMessageEventItem) : gettype($messageEventsTypeMessageEventItem)), __LINE__);
            }
        }
        $this->messageEvent = $messageEvent;
        return $this;
    }
    /**
     * Add item to messageEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\MessageEventType $item
     * @return \StructType\MessageEventsType
     */
    public function addToMessageEvent(\StructType\MessageEventType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MessageEventType) {
            throw new \InvalidArgumentException(sprintf('The messageEvent property can only contain items of \StructType\MessageEventType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->messageEvent[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MessageEventsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
