<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for messageIdentifierType StructType
 * Meta informations extracted from the WSDL
 * - documentation: A compound document and message identity.
 * @subpackage Structs
 */
class MessageIdentifierType extends AbstractStructBase
{
    /**
     * The asicIdentifier
     * Meta informations extracted from the WSDL
     * - documentation: ~Internal~
     * @var \StructType\DocumentIdentifierType
     */
    public $asicIdentifier;
    /**
     * The customerIdentifier
     * @var \StructType\CustomerIdentifier
     */
    public $customerIdentifier;
    /**
     * Constructor method for messageIdentifierType
     * @uses MessageIdentifierType::setAsicIdentifier()
     * @uses MessageIdentifierType::setCustomerIdentifier()
     * @param \StructType\DocumentIdentifierType $asicIdentifier
     * @param \StructType\CustomerIdentifier $customerIdentifier
     */
    public function __construct(\StructType\DocumentIdentifierType $asicIdentifier = null, \StructType\CustomerIdentifier $customerIdentifier = null)
    {
        $this
            ->setAsicIdentifier($asicIdentifier)
            ->setCustomerIdentifier($customerIdentifier);
    }
    /**
     * Get asicIdentifier value
     * @return \StructType\DocumentIdentifierType|null
     */
    public function getAsicIdentifier()
    {
        return $this->asicIdentifier;
    }
    /**
     * Set asicIdentifier value
     * @param \StructType\DocumentIdentifierType $asicIdentifier
     * @return \StructType\MessageIdentifierType
     */
    public function setAsicIdentifier(\StructType\DocumentIdentifierType $asicIdentifier = null)
    {
        $this->asicIdentifier = $asicIdentifier;
        return $this;
    }
    /**
     * Get customerIdentifier value
     * @return \StructType\CustomerIdentifier|null
     */
    public function getCustomerIdentifier()
    {
        return $this->customerIdentifier;
    }
    /**
     * Set customerIdentifier value
     * @param \StructType\CustomerIdentifier $customerIdentifier
     * @return \StructType\MessageIdentifierType
     */
    public function setCustomerIdentifier(\StructType\CustomerIdentifier $customerIdentifier = null)
    {
        $this->customerIdentifier = $customerIdentifier;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MessageIdentifierType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
