<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for nameIndexAcncEntityType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Updated version of nniEntityType for acnc flag
 * @subpackage Structs
 */
class NameIndexAcncEntityType extends NameIndexEntityType
{
    /**
     * The acncFlag
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $acncFlag;
    /**
     * Constructor method for nameIndexAcncEntityType
     * @uses NameIndexAcncEntityType::setAcncFlag()
     * @param bool $acncFlag
     */
    public function __construct($acncFlag = null)
    {
        $this
            ->setAcncFlag($acncFlag);
    }
    /**
     * Get acncFlag value
     * @return bool|null
     */
    public function getAcncFlag()
    {
        return $this->acncFlag;
    }
    /**
     * Set acncFlag value
     * @param bool $acncFlag
     * @return \StructType\NameIndexAcncEntityType
     */
    public function setAcncFlag($acncFlag = null)
    {
        // validation for constraint: boolean
        if (!is_null($acncFlag) && !is_bool($acncFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($acncFlag)), __LINE__);
        }
        $this->acncFlag = $acncFlag;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NameIndexAcncEntityType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
