<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for nameResultType StructType
 * @subpackage Structs
 */
class NameResultType extends AbstractStructBase
{
    /**
     * The nameAvailable
     * @var bool
     */
    public $nameAvailable;
    /**
     * The nameUnavailable
     * Meta informations extracted from the WSDL
     * - documentation: Errors provided in objections
     * @var bool
     */
    public $nameUnavailable;
    /**
     * The nameSubjectToNamesDetermination
     * Meta informations extracted from the WSDL
     * - documentation: Reasons provided in objections
     * @var bool
     */
    public $nameSubjectToNamesDetermination;
    /**
     * Constructor method for nameResultType
     * @uses NameResultType::setNameAvailable()
     * @uses NameResultType::setNameUnavailable()
     * @uses NameResultType::setNameSubjectToNamesDetermination()
     * @param bool $nameAvailable
     * @param bool $nameUnavailable
     * @param bool $nameSubjectToNamesDetermination
     */
    public function __construct($nameAvailable = null, $nameUnavailable = null, $nameSubjectToNamesDetermination = null)
    {
        $this
            ->setNameAvailable($nameAvailable)
            ->setNameUnavailable($nameUnavailable)
            ->setNameSubjectToNamesDetermination($nameSubjectToNamesDetermination);
    }
    /**
     * Get nameAvailable value
     * @return bool|null
     */
    public function getNameAvailable()
    {
        return $this->nameAvailable;
    }
    /**
     * Set nameAvailable value
     * @param bool $nameAvailable
     * @return \StructType\NameResultType
     */
    public function setNameAvailable($nameAvailable = null)
    {
        // validation for constraint: boolean
        if (!is_null($nameAvailable) && !is_bool($nameAvailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nameAvailable)), __LINE__);
        }
        $this->nameAvailable = $nameAvailable;
        return $this;
    }
    /**
     * Get nameUnavailable value
     * @return bool|null
     */
    public function getNameUnavailable()
    {
        return $this->nameUnavailable;
    }
    /**
     * Set nameUnavailable value
     * @param bool $nameUnavailable
     * @return \StructType\NameResultType
     */
    public function setNameUnavailable($nameUnavailable = null)
    {
        // validation for constraint: boolean
        if (!is_null($nameUnavailable) && !is_bool($nameUnavailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nameUnavailable)), __LINE__);
        }
        $this->nameUnavailable = $nameUnavailable;
        return $this;
    }
    /**
     * Get nameSubjectToNamesDetermination value
     * @return bool|null
     */
    public function getNameSubjectToNamesDetermination()
    {
        return $this->nameSubjectToNamesDetermination;
    }
    /**
     * Set nameSubjectToNamesDetermination value
     * @param bool $nameSubjectToNamesDetermination
     * @return \StructType\NameResultType
     */
    public function setNameSubjectToNamesDetermination($nameSubjectToNamesDetermination = null)
    {
        // validation for constraint: boolean
        if (!is_null($nameSubjectToNamesDetermination) && !is_bool($nameSubjectToNamesDetermination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nameSubjectToNamesDetermination)), __LINE__);
        }
        $this->nameSubjectToNamesDetermination = $nameSubjectToNamesDetermination;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NameResultType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
