<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for nameResultWithObjectionsType StructType
 * @subpackage Structs
 */
class NameResultWithObjectionsType extends NameResultType
{
    /**
     * The objections
     * Meta informations extracted from the WSDL
     * - maxOccurs: 20
     * - minOccurs: 0
     * @var \StructType\ObjectionType[]
     */
    public $objections;
    /**
     * Constructor method for nameResultWithObjectionsType
     * @uses NameResultWithObjectionsType::setObjections()
     * @param \StructType\ObjectionType[] $objections
     */
    public function __construct(array $objections = array())
    {
        $this
            ->setObjections($objections);
    }
    /**
     * Get objections value
     * @return \StructType\ObjectionType[]|null
     */
    public function getObjections()
    {
        return $this->objections;
    }
    /**
     * Set objections value
     * @throws \InvalidArgumentException
     * @param \StructType\ObjectionType[] $objections
     * @return \StructType\NameResultWithObjectionsType
     */
    public function setObjections(array $objections = array())
    {
        foreach ($objections as $nameResultWithObjectionsTypeObjectionsItem) {
            // validation for constraint: itemType
            if (!$nameResultWithObjectionsTypeObjectionsItem instanceof \StructType\ObjectionType) {
                throw new \InvalidArgumentException(sprintf('The objections property can only contain items of \StructType\ObjectionType, "%s" given', is_object($nameResultWithObjectionsTypeObjectionsItem) ? get_class($nameResultWithObjectionsTypeObjectionsItem) : gettype($nameResultWithObjectionsTypeObjectionsItem)), __LINE__);
            }
        }
        $this->objections = $objections;
        return $this;
    }
    /**
     * Add item to objections value
     * @throws \InvalidArgumentException
     * @param \StructType\ObjectionType $item
     * @return \StructType\NameResultWithObjectionsType
     */
    public function addToObjections(\StructType\ObjectionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ObjectionType) {
            throw new \InvalidArgumentException(sprintf('The objections property can only contain items of \StructType\ObjectionType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->objections[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NameResultWithObjectionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
