<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for queryNameAvailabilityRequestType StructType
 * @subpackage Structs
 */
class QueryNameAvailabilityRequestType extends AbstractStructBase
{
    /**
     * The businessDocumentHeader
     * Meta informations extracted from the WSDL
     * - ref: business.document.header.types:businessDocumentHeader
     * @var \StructType\BusinessDocumentHeaderType
     */
    public $businessDocumentHeader;
    /**
     * The businessDocumentBody
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\QueryNniNameType
     */
    public $businessDocumentBody;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - ref: wsu:Id
     * @var string
     */
    public $Id;
    /**
     * Constructor method for queryNameAvailabilityRequestType
     * @uses QueryNameAvailabilityRequestType::setBusinessDocumentHeader()
     * @uses QueryNameAvailabilityRequestType::setBusinessDocumentBody()
     * @uses QueryNameAvailabilityRequestType::setId()
     * @param \StructType\BusinessDocumentHeaderType $businessDocumentHeader
     * @param \StructType\QueryNniNameType $businessDocumentBody
     * @param string $id
     */
    public function __construct(\StructType\BusinessDocumentHeaderType $businessDocumentHeader = null, \StructType\QueryNniNameType $businessDocumentBody = null, $id = null)
    {
        $this
            ->setBusinessDocumentHeader($businessDocumentHeader)
            ->setBusinessDocumentBody($businessDocumentBody)
            ->setId($id);
    }
    /**
     * Get businessDocumentHeader value
     * @return \StructType\BusinessDocumentHeaderType|null
     */
    public function getBusinessDocumentHeader()
    {
        return $this->businessDocumentHeader;
    }
    /**
     * Set businessDocumentHeader value
     * @param \StructType\BusinessDocumentHeaderType $businessDocumentHeader
     * @return \StructType\QueryNameAvailabilityRequestType
     */
    public function setBusinessDocumentHeader(\StructType\BusinessDocumentHeaderType $businessDocumentHeader = null)
    {
        $this->businessDocumentHeader = $businessDocumentHeader;
        return $this;
    }
    /**
     * Get businessDocumentBody value
     * @return \StructType\QueryNniNameType|null
     */
    public function getBusinessDocumentBody()
    {
        return $this->businessDocumentBody;
    }
    /**
     * Set businessDocumentBody value
     * @param \StructType\QueryNniNameType $businessDocumentBody
     * @return \StructType\QueryNameAvailabilityRequestType
     */
    public function setBusinessDocumentBody(\StructType\QueryNniNameType $businessDocumentBody = null)
    {
        $this->businessDocumentBody = $businessDocumentBody;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\QueryNameAvailabilityRequestType
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\QueryNameAvailabilityRequestType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
