<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for realmIdentifierType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Identity for a realm.
 * @subpackage Structs
 */
class RealmIdentifierType extends AbstractStructBase
{
    /**
     * The realm
     * @var \StructType\RealmQualifierType
     */
    public $realm;
    /**
     * Constructor method for realmIdentifierType
     * @uses RealmIdentifierType::setRealm()
     * @param \StructType\RealmQualifierType $realm
     */
    public function __construct(\StructType\RealmQualifierType $realm = null)
    {
        $this
            ->setRealm($realm);
    }
    /**
     * Get realm value
     * @return \StructType\RealmQualifierType|null
     */
    public function getRealm()
    {
        return $this->realm;
    }
    /**
     * Set realm value
     * @param \StructType\RealmQualifierType $realm
     * @return \StructType\RealmIdentifierType
     */
    public function setRealm(\StructType\RealmQualifierType $realm = null)
    {
        $this->realm = $realm;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RealmIdentifierType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
