<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for requestType StructType
 * @subpackage Structs
 */
class RequestType extends AbstractStructBase
{
    /**
     * The messageHeader
     * @var \StructType\StandardMessageHeaderType
     */
    public $messageHeader;
    /**
     * The messageIdentifier
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageIdentifierType
     */
    public $messageIdentifier;
    /**
     * The timestampList
     * Meta informations extracted from the WSDL
     * - documentation: ~Internal~
     * - minOccurs: 0
     * @var \StructType\TimestampListType
     */
    public $timestampList;
    /**
     * Constructor method for requestType
     * @uses RequestType::setMessageHeader()
     * @uses RequestType::setMessageIdentifier()
     * @uses RequestType::setTimestampList()
     * @param \StructType\StandardMessageHeaderType $messageHeader
     * @param \StructType\MessageIdentifierType $messageIdentifier
     * @param \StructType\TimestampListType $timestampList
     */
    public function __construct(\StructType\StandardMessageHeaderType $messageHeader = null, \StructType\MessageIdentifierType $messageIdentifier = null, \StructType\TimestampListType $timestampList = null)
    {
        $this
            ->setMessageHeader($messageHeader)
            ->setMessageIdentifier($messageIdentifier)
            ->setTimestampList($timestampList);
    }
    /**
     * Get messageHeader value
     * @return \StructType\StandardMessageHeaderType|null
     */
    public function getMessageHeader()
    {
        return $this->messageHeader;
    }
    /**
     * Set messageHeader value
     * @param \StructType\StandardMessageHeaderType $messageHeader
     * @return \StructType\RequestType
     */
    public function setMessageHeader(\StructType\StandardMessageHeaderType $messageHeader = null)
    {
        $this->messageHeader = $messageHeader;
        return $this;
    }
    /**
     * Get messageIdentifier value
     * @return \StructType\MessageIdentifierType|null
     */
    public function getMessageIdentifier()
    {
        return $this->messageIdentifier;
    }
    /**
     * Set messageIdentifier value
     * @param \StructType\MessageIdentifierType $messageIdentifier
     * @return \StructType\RequestType
     */
    public function setMessageIdentifier(\StructType\MessageIdentifierType $messageIdentifier = null)
    {
        $this->messageIdentifier = $messageIdentifier;
        return $this;
    }
    /**
     * Get timestampList value
     * @return \StructType\TimestampListType|null
     */
    public function getTimestampList()
    {
        return $this->timestampList;
    }
    /**
     * Set timestampList value
     * @param \StructType\TimestampListType $timestampList
     * @return \StructType\RequestType
     */
    public function setTimestampList(\StructType\TimestampListType $timestampList = null)
    {
        $this->timestampList = $timestampList;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RequestType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
