<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for timestampListType StructType
 * Meta informations extracted from the WSDL
 * - documentation: ~Internal~
 * @subpackage Structs
 */
class TimestampListType extends AbstractStructBase
{
    /**
     * The timestamp
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TimestampType[]
     */
    public $timestamp;
    /**
     * Constructor method for timestampListType
     * @uses TimestampListType::setTimestamp()
     * @param \StructType\TimestampType[] $timestamp
     */
    public function __construct(array $timestamp = array())
    {
        $this
            ->setTimestamp($timestamp);
    }
    /**
     * Get timestamp value
     * @return \StructType\TimestampType[]|null
     */
    public function getTimestamp()
    {
        return $this->timestamp;
    }
    /**
     * Set timestamp value
     * @throws \InvalidArgumentException
     * @param \StructType\TimestampType[] $timestamp
     * @return \StructType\TimestampListType
     */
    public function setTimestamp(array $timestamp = array())
    {
        foreach ($timestamp as $timestampListTypeTimestampItem) {
            // validation for constraint: itemType
            if (!$timestampListTypeTimestampItem instanceof \StructType\TimestampType) {
                throw new \InvalidArgumentException(sprintf('The timestamp property can only contain items of \StructType\TimestampType, "%s" given', is_object($timestampListTypeTimestampItem) ? get_class($timestampListTypeTimestampItem) : gettype($timestampListTypeTimestampItem)), __LINE__);
            }
        }
        $this->timestamp = $timestamp;
        return $this;
    }
    /**
     * Add item to timestamp value
     * @throws \InvalidArgumentException
     * @param \StructType\TimestampType $item
     * @return \StructType\TimestampListType
     */
    public function addToTimestamp(\StructType\TimestampType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TimestampType) {
            throw new \InvalidArgumentException(sprintf('The timestamp property can only contain items of \StructType\TimestampType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->timestamp[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TimestampListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
